//+------------------------------------------------------------------+
//|                                MovingAverage - Angel Broking.mq4 |
//|                                        Copyright 2021, Algomojo. |
//|                                         https://www.algomojo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Algomojo."
#property link      "https://www.algomojo.com"
#property version   "1.00"
#property strict
#property script_show_inputs
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+



//Algomojo Autotrading Modules

input string user_apikey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API key here
input string api_secretkey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API secret key here

input string tradingsymbol = "NIFTY29JUL21FUT"; //Symbol Name
input int symboltoken = 53181;

enum exch{
   NSE,
   BSE,
   NFO,
   MCX
};

enum otype{
   MARKET,
   LIMIT,
   STOPLOSS_LIMIT,
   STOPLOSS_MARKET

};

enum ptype{
   DELIVERY,
   CARRYFORWARD,
   MARGIN,
   INTRADAY,
   AMO_MARGIN,
   AMO_DELIVERY,
   AMO_CARRYFORWARD
};

enum var{
   NORMAL,
   STOPLOSS,
   AMO
};


enum br{
   an
};


  

input exch exchange = NFO; //Exchange
input otype ordertype =MARKET; // Order Type
input ptype producttype =INTRADAY; // Product Code
input var variety = NORMAL; // Variety
input int price = 0;
input int triggerprice = 0;
input int quantity = 50;
input int squareoff = 0;
input int stoploss = 0;
input int trailingStopLoss  = 0;
input int disclosedquantity = 0;
input string duration = "DAY";



input string stgy_name = "Metatrader Strategy"; // Strategy Name
input br broker = an; //Broker Short code ab - aliceblue, tj- tradejini, zb - zebu , en - enrich
input string ver = "1.0"; //API Version


string response;
string api_data;
int Buy;
int Sell;

static int BarsOnChart;

#import "AMMT4BRIDGE.dll"
     string AMDispatcher(string api_key, string api_secret, string api_name, string api_data, string br_code, string version);
#import

//+------------------------------------------------------------------+
//| BuyOrder  function                                               |
//+------------------------------------------------------------------+  

void BuyOrder(int orderquantity)
   {
  
     //Algomojo Place Buy Order


      api_data ="{\"stgy_name\":\""+stgy_name+"\",\"variety\":\""+EnumToString(variety)+"\",\"tradingsymbol\":\""+tradingsymbol+"\",\"symboltoken\":\""+IntegerToString(symboltoken)+"\",\"transactiontype\":\""+"BUY"+"\",\"exchange\":\""+EnumToString(exchange)+"\",\"ordertype\":\""+EnumToString(ordertype)+"\",\"producttype\":\""+EnumToString(producttype)+"\",\"duration\":\""+duration+"\",\"price\":\""+IntegerToString(price)+"\",\"squareoff\":\""+IntegerToString(squareoff)+"\",\"stoploss\":\""+IntegerToString(stoploss)+"\",\"quantity\":\""+IntegerToString(orderquantity)+"\",\"triggerprice\":\""+IntegerToString(triggerprice)+"\",\"trailingStopLoss\":\""+IntegerToString(trailingStopLoss)+"\",\"disclosedquantity\":\""+IntegerToString(disclosedquantity)+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Buy Order response : " ,response);
      
      
    }


//+------------------------------------------------------------------+
//| SellOrder  function                                              |
//+------------------------------------------------------------------+    
    
void SellOrder(int orderquantity)
   {
  
      //Algomojo Place Sell Order
      api_data ="{\"stgy_name\":\""+stgy_name+"\",\"variety\":\""+EnumToString(variety)+"\",\"tradingsymbol\":\""+tradingsymbol+"\",\"symboltoken\":\""+IntegerToString(symboltoken)+"\",\"transactiontype\":\""+"SELL"+"\",\"exchange\":\""+EnumToString(exchange)+"\",\"ordertype\":\""+EnumToString(ordertype)+"\",\"producttype\":\""+EnumToString(producttype)+"\",\"duration\":\""+duration+"\",\"price\":\""+IntegerToString(price)+"\",\"squareoff\":\""+IntegerToString(squareoff)+"\",\"stoploss\":\""+IntegerToString(stoploss)+"\",\"quantity\":\""+IntegerToString(orderquantity)+"\",\"triggerprice\":\""+IntegerToString(triggerprice)+"\",\"trailingStopLoss\":\""+IntegerToString(trailingStopLoss)+"\",\"disclosedquantity\":\""+IntegerToString(disclosedquantity)+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Sell Order response : " ,response);
         
   
   
   }         

int OnInit()
  {
//---
  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---   
   Buy = Close[1] > EMA(10,1)  && Close[2] < EMA(10,2);
   Sell = Close[1] < EMA(10,1) && Close[2] > EMA(10,2);
   
   if(Buy && BarsOnChart != Bars) {      
       BuyOrder(quantity);
       Print("Buy Signal");
       BarsOnChart = Bars;
       PlaySound("Ok.wav");
   }
  
   
   if(Sell && BarsOnChart != Bars) {
      SellOrder(quantity);
      Print("Sell Signal");
      BarsOnChart = Bars;
      PlaySound("Ok.wav");
   }   
  
  }
//+------------------------------------------------------------------+

double EMA(int period,int shift) {
   return iMA(Symbol(), 0, period, 0, MODE_EMA, PRICE_CLOSE, shift);
  
}




