//+------------------------------------------------------------------+
//|                                 MovingAverage - Nest Brokers.mq4 |
//|                                        Copyright 2021, Algomojo. |
//|                                         https://www.algomojo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Algomojo."
#property link      "https://www.algomojo.com"
#property version   "1.00"
#property strict
#property script_show_inputs
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+



//Algomojo Autotrading Modules

input string user_apikey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API key here
input string api_secretkey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API secret key here

input string Tsym = "NIFTY29JUL21FUT"; //Symbol Name


enum exchange{
   NSE,
   NFO,
   MCX
};

enum Product{
   NRML,
   MIS,
   CNC
};

enum br{
   ab,
   mt,
   tj,
   zb
};


  

input exchange exch = NFO; //Exchange
input string prctyp = "MKT"; // Pricetype
input Product Pcode = MIS; // Product Code
input int qty = 50; // Quantity

input string stgy_name = "Metatrader Strategy"; // Strategy Name
input br broker = ab; //Broker Short code ab - aliceblue, tj- tradejini, zb - zebu , en - enrich
input string ver = "1.0"; //API Version

string s_prdt_ali = "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML";
string Ret = "DAY"; //Retention
string AMO = "NO"; //AMO Order
string response;
string api_data;
int Buy;
int Sell;

static int BarsOnChart;

#import "AMMT4BRIDGE.dll"
     string AMDispatcher(string api_key, string api_secret, string api_name, string api_data, string br_code, string version);
#import



void BuyOrder(int quantity)
   {
  
     //Algomojo Place Buy Order


      api_data ="{\"stgy_name\":\""+stgy_name+"\",\"s_prdt_ali\":\""+s_prdt_ali+"\",\"Tsym\":\""+Tsym+"\",\"exch\":\""+EnumToString(exch)+"\",\"Ttranstype\":\""+"B"+"\",\"Ret\":\""+Ret+"\",\"prctyp\":\""+prctyp+"\",\"qty\":\""+IntegerToString(quantity)+"\",\"discqty\":\""+"0"+"\",\"MktPro\":\""+"NA"+"\",\"Price\":\""+"0"+"\",\"TrigPrice\":\""+"0"+"\",\"Pcode\":\""+EnumToString(Pcode)+"\",\"AMO\":\""+AMO+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Buy Order response : " ,response);
      
      
    }


//+------------------------------------------------------------------+
//| SellOrder  function                                              |
//+------------------------------------------------------------------+    
    
void SellOrder(int quantity)
   {
  
      //Algomojo Place Sell Order
      api_data ="{\"stgy_name\":\""+stgy_name+"\",\"s_prdt_ali\":\""+s_prdt_ali+"\",\"Tsym\":\""+Tsym+"\",\"exch\":\""+EnumToString(exch)+"\",\"Ttranstype\":\""+"S"+"\",\"Ret\":\""+Ret+"\",\"prctyp\":\""+prctyp+"\",\"qty\":\""+IntegerToString(quantity)+"\",\"discqty\":\""+"0"+"\",\"MktPro\":\""+"NA"+"\",\"Price\":\""+"0"+"\",\"TrigPrice\":\""+"0"+"\",\"Pcode\":\""+EnumToString(Pcode)+"\",\"AMO\":\""+AMO+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Sell Order response : " ,response);
         
   
   
   }         

int OnInit()
  {
//---
  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---   
   Buy = Close[1] > EMA(10,1)  && Close[2] < EMA(10,2);
   Sell = Close[1] < EMA(10,1) && Close[2] > EMA(10,2);
   
   if(Buy && BarsOnChart != Bars) {      
       BuyOrder(qty);
       Print("Buy Signal");
       BarsOnChart = Bars;
       PlaySound("Ok.wav");
   }
  
   
   if(Sell && BarsOnChart != Bars) {
      SellOrder(qty);
      Print("Sell Signal");
      BarsOnChart = Bars;
      PlaySound("Ok.wav");
   }   
  
  }
//+------------------------------------------------------------------+

double EMA(int period,int shift) {
   return iMA(Symbol(), 0, period, 0, MODE_EMA, PRICE_CLOSE, shift);
  
}




